{  Tietotekniikan cum laude approbaturin valinnainen harjoitusty.

   Kevt 1988 - kes 1989 (korjauksia viel syksyll 1989).

   Tehtvn oli laatia Pascal-ohjelma, joka laskee merkkijonona
   annetun lausekkeen. Lausekkeessa saa olla vakioita ja muuttujia ja
   funktioita ( mukana ovat kaikki TurboPascalin valmiit funktiot
   + tangentti). Laskutoimitukset tapahtuvat reaaliluvuilla.

   Tyn ohjaajana on toiminut Tapani Tarvainen.

   Tehdyist aliohjelmista on tehty TurboPascal Unit.
}



Unit Calc;

{============================================================================}
InterFace

{$I Global.Def}  { Unit:n globaalit mrittelyt }

{ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

{ Aliohjelma knt annetun merkkijonon infix-muodosta suffix-muotoiseen
  listaan. Samalla tehdn lausekkeen syntaksitarkistus. Virhetilanteissa
  palautetaan muuttujassa Error osoitin merkkijonon kohtaan, jossa virhe
  havaittiin. Muuttujia kytettess voidaan antaa ns. ensisijaisen muut-
  tujan nimi parametrissa Variable. Tlle muuttujalle annetaan arvo las-
  kenta-aliohjelman kutsussa. Muille muuttujille voidaan antaa arvo my-
  hemmin esiteltvll Let-aliohjelmalla.
}
Procedure Compile(     Jono      : AnyString;     { laskettava lauseke }
                       Variable  : VarString;     { ensisijainen muutuja }
                   Var DList     : FunktioJono;   { knnetty lauseke }
                   Var Error     : Integer);      { virheparametri }


{ Aliohjelmalla lasketaan knnetyn listan arvo, joka palautetaan
  muuttujassa Result. Ensisijaisen muuttujan arvo vlitetn muuttujassa
  Value.
}
Procedure EvaluateReal(     DList  : FunktioJono;   { laskettava lauseke }
                            Value  : Luku;          { ensisijaisen muuttujan }
                                                    { arvo }
                        Var Result : Luku);         { laskettu tulos }


{ Aliohjelmalla asetetaan muuttujan Variable arvoksi Value. Jos muuttuja
  on jo ennestn olemassa, niin sen arvo muutetaan, mutta jos muuttuja
  on uusi, niin se luodaan (tilan salliessa). Muuttujia voi olla korkein-
  taan 10 kpl. Jos muuttuja ei saada luoduksi, palautetaan muuttujassa
  Virhe virhekoodi seuraavasti:
           0 : ei virhett
          -1 : tuntematon muuttujan tyyppi
           1 : taulukossa ei ole tilaa muuttujalle
}
Procedure Let(     Variable : VarString;  { asetettavan muuttujan nimi }
                   Value    : Luku;       { ja sen arvo }
               Var Virhe    : Integer);   { Tosi, jos muuttujaa ei saatu }
                                          { luotua }

{ Aliohjelma nollaa muuttujataulukon. e ja pi jtetn kuitenkin muuttamatta.
}
Procedure ClearVars;



{============================================================================}
Implementation

{$I Local.Def}          { Paikalliset mritykset }

{$I Util.Pas}           { Pienimuotoisia apurutiineja. }

{$I Custom.Pas}         { Laskujrjestyst ksittelevt rutiinit }

{$I Funktiot.Pas}       { Varsinaiset laskurutiinit. }

{$I InToSuf.Pas}        { Infix To Suffix -konversio. }


{ Aliohjelma knt annetun merkkijonon infix-muodosta suffix-muotoiseen
  listaan. Samalla tehdn lausekkeen syntaksitarkistus. Virhetilanteissa
  palautetaan muuttujassa Error osoitin merkkijonon kohtaan, jossa virhe
  havaittiin. Muuttujia kytettess voidaan antaa ns. ensisijaisen muut-
  tujan nimi parametrissa Variable. Tlle muuttujalle annetaan arvo las-
  kenta-aliohjelman kutsussa. Muille muuttujille voidaan antaa arvo my-
  hemmin esiteltvll Let-aliohjelmalla.

Procedure Compile(     Jono      : AnyString;     { laskettava lauseke
                       Variable  : VarString;     { ensisijainen muutuja
                   Var DList     : FunktioJono;   { knnetty lauseke
                   Var Error     : Integer);      { virheparametri
}
Procedure Compile;
Begin
  VakioArvot[1].Nimi:=Variable;     { Asetetaan taulukkoon ensisijaisen    }
  Pieneksi(Jono);                   { muuttijan nimi ja muutetaan koko     }
  InfixToSuffix(Jono,Dlist,Error);  { merkkijono pieniksi kirjaimiksi sek }
End; { Compile }                    { kutsutaan konversioaliohjelmaa.      }


{ Aliohjelmalla lasketaan knnetyn listan arvo, joka palautetaan
  muuttujassa Result. Ensisijaisen muuttujan arvo vlitetn muuttujassa
  Value.

Procedure EvaluateReal(     DList  : FunktioJono;   { laskettava lauseke
                            Value  : Luku;          { ensisijaisen muuttujan
                                                    { arvo
                        Var Result : Luku);         { laskettu tulos
}
Procedure EvaluateReal;
Begin
  VakioArvot[1].Arvo:=Value;        { Talletetaan ensisijaisen muuttujan   }
  LaskeFunktio(Dlist,Result);       { arvo taulukkoon ja kutsutaan lasken- }
End; { EvaluateReal }               { taaliohjelmaa.                       }

{ Aliohjelmalla asetetaan muuttujan Variable arvoksi Value. Jos muuttuja
  on jo ennestn olemassa, niin sen arvo muutetaan, mutta jos muuttuja
  on uusi, niin se luodaan (tilan salliessa). Muuttujia voi olla korkein-
  taan 10 kpl. Jos muuttuja ei saada luoduksi, palautetaan muuttujassa
  Virhe virhekoodi seuraavasti:
           0 : ei virhett
          -1 : tuntematon muuttujan tyyppi
          -2 : muuttujan nimi oli e tai pi (valmiiksi mriteltyj!)
           1 : taulukossa ei ole tilaa muuttujalle

Procedure Let(     Variable : VarString;  { asetettavan muuttujan nimi
                   Value    : Luku;       { ja sen arvo
               Var Virhe    : Integer);   { Tosi, jos muuttujaa ei saatu
                                          { luotua
}
Procedure Let;
Var Oli : Boolean;  { Apumuuttuja ilmoittamaan mahdollisesti lytynytt }
    i   : VakioIndex;  { vakiota. i on osoitin VakioArvot -taulukkoon.  }
Begin
  Virhe:=OK;    { Oletetaan, ett taulukko ei tyty eik ole muita virheit }
  Oli:=False;   { viel ei lytynyt mitn }
  If (Variable = 'pi') Or (Variable = 'e') Then Begin
                           { Jos kyttj antaa muut-                        }
    Virhe:=WrongName;      { tujan nimen 'e' tai 'pi', niin palautetaan     }
    Exit;                  { virhe ja poistutaan aliohjelmasta.              }
  End;  { Luonnonvakioita ei ole jrke mritell uudelleen, Luoja loi ne...}
  If (Value.Tyyppi <> Reali) And (Value.Tyyppi <> Complexi) Then Begin
    Virhe:=UnKnown; { Muuttujan tyyppi on tuntematon, palautetaan virhe. }
    Exit;
  End;
  If VakioOsoitin >= FirstVar Then Begin       { On alustettuja muuttujia. }
    i:=FirstVar;     { Aloitetaan ensimmisest mahdollisesta muuttujasta. }
    Repeat            { Pyritn silmukassa kunnes koko taulukko on kyty }
                      { lpi tai muuttuja on lytynyt.                     }
      If VakioArvot[i].Nimi = Variable Then Begin  { Jos muuttuja lytyy,  }
        VakioArvot[i].Arvo:=Value;
        Oli:=True;                       { Merkitn muuttuja lydetyksi.  }
      End; { lytyi }
      i:=Succ(i);
    Until (i >= VakioOsoitin) Or (Oli); { VakioOsoitin osoittaa viimeiseen }
                       { kytss olevaan alkioon VakioArvot -taulukossa.  }
  End; { Oli alustettuja muuttujia. }
  If Not Oli Then Begin { Tehdn uusi muuttuja (siis ei lytynyt tll  }
    If VakioOsoitin = MaxVakioita Then Begin { nimell vanhaa muuttujaa. }
      Virhe:=NoRoom;   { Jos taulukko on tynn, niin palautetaan virhe. }
    End
    Else Begin
      VakioOsoitin:=Succ(VakioOsoitin);       { Laiteetaan uusi muuttuja }
      VakioArvot[VakioOsoitin].Nimi:=Variable;
      VakioArvot[VakioOsoitin].Arvo:=Value;
    End; { taulukossa oli tilaa }
  End; { laitettiin uusi muuttuja }
End; { Let }

{ Aliohjelma nollaa muuttujataulukon. e ja pi jtetn kuitenkin muuttamatta.
}
Procedure ClearVars;
Var  i : VakioIndex;
Begin
  VakioArvot[1].Nimi:='';    { Nollataan mys ensisijainen muuttuja.    }
  For i:=FirstVar To MaxVakioita Do Begin { Ei nollata e:t eik pi:t. }
    VakioArvot[i].Nimi:='';        { Koska muuttujia ksitelln nimen  }
  End;                             { perusteella, nollaukseksi riitt  }
 VakioOsoitin:=3;                  { nimen poisto.                      }
End; { ClearVars }


{ Aliohjelmalla alustetaan muutamia globaaleja muuttujia. Taulukon ensimminen
  paikka on varattu ensisijaiselle muuttujalle.
}
Procedure Alusta;
Begin
  VakioArvot[2].Nimi:='pi'; VakioArvot[2].Arvo.Tyyppi:=Reali;
  VakioArvot[2].Arvo.Arvo:=3.14159265359;
  VakioArvot[3].Nimi:='e';  VakioArvot[3].Arvo.Tyyppi:=Reali;
  VakioArvot[3].Arvo.Arvo:=2.71828182846;
  VakioOsoitin:=3;
End; { Alusta }


Begin { Pohjelma }
  Alusta;
End.  { Pohjelma }

